#!/bin/sh

SSO_CONFIG=/etc/sso/sso_config.ini

NEW_SP_ID=$1
OLD_SP_ID=`grep -oE 'privileged_sp_id[ ]*=[ ]*[0-9a-zA-Z]*' $SSO_CONFIG | grep -oE '[^= ][0-9a-zA-Z]*$'`

init() {
	grep "privileged_sp_id" $SSO_CONFIG >/dev/null && update_sp_id && exit 0
	add_sp_id
}

add_sp_id() {
	echo
	echo "Add new option 'privileged_sp_id' into SSO config."

	echo >> $SSO_CONFIG
	echo >> $SSO_CONFIG
	echo "; Super Privileged Service Provider" >> $SSO_CONFIG
	echo "privileged_sp_id = $NEW_SP_ID" >> $SSO_CONFIG
	echo >> $SSO_CONFIG

	echo
	echo "Done."
	echo

	exit 0
}

update_sp_id() {
	echo
	echo "Change option 'privileged_sp_id' in SSO config."

	sed -e "s|privileged_sp_id[ ]*=[ ]*$OLD_SP_ID|privileged_sp_id = $NEW_SP_ID|g" $SSO_CONFIG > ${SSO_CONFIG}_out
	mv -f ${SSO_CONFIG}_out $SSO_CONFIG

	echo
	echo "Done."
	echo

	exit 0
}

init
