#!/bin/sh
#
# Produces IPV6 configuration options for sw-cp-server SSO configuration.
# Ensures that no collision occures with similar options used by Plesk.
#

if [ "`id -u`" -ne 0 ]; then
	exit 0
fi

PORT="$1"
IPV6="$2"

if [ -z "$PORT" -o -z "$IPV6" -o "$IPV6" != "yes" ]; then
	exit 0
fi

CERT_FILE="/etc/sso/sso.pem"
PSA_CONF="/etc/sw-cp-server/applications.d/plesk.conf"
PSA_IPV6_CONF="/etc/sw-cp-server/applications.d/plesk.socket.sh"

if [ -f "$PSA_CONF" -a -x "$PSA_IPV6_CONF" ]; then
	conf=`$PSA_IPV6_CONF $PORT ipv6`
fi

if ! (echo "$conf" | grep -q 'server\.use-ipv6'); then
	echo 'server.use-ipv6 = "enable"'
fi

